import React from 'react';
import PropTypes from 'prop-types';
import { field } from '../prop-types';
import { FIELDS, DISPLAYS } from '../Standard';
import DefaultSelect from './Default';
import AutosuggestSelect from './Autosuggest';

var Select = function Select(_ref) {
  var select = _ref.select,
      onChange = _ref.onChange,
      tabIndex = _ref.tabIndex,
      size = _ref.size,
      errors = _ref.errors;
  var Field;

  switch (select.display) {
    case DISPLAYS[FIELDS.PICKER].AUTOCOMPLETE:
      Field = React.createElement(AutosuggestSelect, {
        select: select,
        onChange: onChange,
        tabIndex: tabIndex,
        size: size,
        errors: errors
      });
      break;

    case DISPLAYS[FIELDS.PICKER].DROPDOWN:
    default:
      // TODO: default case mantains backwards compatibility
      Field = React.createElement(DefaultSelect, {
        select: select,
        onChange: onChange,
        tabIndex: tabIndex,
        size: size,
        errors: errors
      });
  }

  return Field;
};

Select.displayName = 'Select';
export default Select;