import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React, { useCallback } from 'react';
import PropTypes from 'prop-types';
import { field } from '../prop-types';
import MoleculeSwitch from '@s-ui/react-atom-switch';

var Switch = function Switch(_ref) {
  var switchField = _ref.switchField,
      tabIndex = _ref.tabIndex,
      onChange = _ref.onChange,
      errors = _ref.errors;
  var errorMessages = errors[switchField.id];
  var onChangeCallback = useCallback(function (value) {
    return onChange(switchField.id, JSON.stringify(value));
  }, [onChange, switchField]);
  var id = switchField.id;

  var switchProps = _objectSpread({
    name: id,
    label: switchField.label,
    labelLeft: 'NOP',
    labelRight: 'ZIP',
    value: JSON.parse(switchField.value || 'false'),
    onToggle: onChangeCallback,
    type: 'single'
  }, switchField.disabled && {
    disabled: true
  }, {}, switchField.hidden && {
    hidden: true
  }, {}, !!errorMessages && {
    errorText: errorMessages.join('\n')
  });

  if (switchProps.hidden) {
    return null;
  }

  return React.createElement("div", {
    className: "sui-FormBuilder-field sui-FormBuilder-Switch sui-FormBuilder-" + (switchProps.id || tabIndex)
  }, React.createElement(MoleculeSwitch, switchProps));
};

Switch.displayName = 'Switch';
export default Switch;