import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React, { useCallback } from 'react';
import PropTypes from 'prop-types';
import { field } from '../prop-types';
import MoleculeTextAreaField from '@s-ui/react-molecule-textarea-field';

var TextArea = function TextArea(_ref) {
  var textArea = _ref.textArea,
      tabIndex = _ref.tabIndex,
      onChange = _ref.onChange,
      errors = _ref.errors;
  var errorMessages = errors[textArea.id];
  var onChangeCallback = useCallback(function (evt) {
    return onChange(textArea.id, evt.target.value);
  }, [onChange, textArea]);
  var nextProps = {}; // transform constraints to props

  var constraints = textArea.constraints || [];
  nextProps = constraints.reduce(function (acc, constraint) {
    var _constraint$property, _constraint$property2, _constraint$property3, _constraint$property4, _constraint$property5, _constraint$property6, _constraint$property7;

    return _objectSpread({}, acc, {}, (constraint === null || constraint === void 0 ? void 0 : (_constraint$property = constraint.property) === null || _constraint$property === void 0 ? void 0 : _constraint$property.maxlength) && {
      maxChars: constraint === null || constraint === void 0 ? void 0 : (_constraint$property2 = constraint.property) === null || _constraint$property2 === void 0 ? void 0 : _constraint$property2.maxlength
    }, {}, (constraint === null || constraint === void 0 ? void 0 : (_constraint$property3 = constraint.property) === null || _constraint$property3 === void 0 ? void 0 : _constraint$property3.maxlength) && {
      maxLength: constraint === null || constraint === void 0 ? void 0 : (_constraint$property4 = constraint.property) === null || _constraint$property4 === void 0 ? void 0 : _constraint$property4.maxlength
    }, {}, (constraint === null || constraint === void 0 ? void 0 : (_constraint$property5 = constraint.property) === null || _constraint$property5 === void 0 ? void 0 : _constraint$property5.minlength) && {
      minLength: constraint === null || constraint === void 0 ? void 0 : (_constraint$property6 = constraint.property) === null || _constraint$property6 === void 0 ? void 0 : _constraint$property6.minlength
    }, {}, (constraint === null || constraint === void 0 ? void 0 : (_constraint$property7 = constraint.property) === null || _constraint$property7 === void 0 ? void 0 : _constraint$property7.notnull) === '' && {
      required: true
    });
  }, nextProps);
  nextProps = _objectSpread({}, nextProps, {}, textArea.hidden && {
    hidden: true
  }, {}, textArea.disabled && {
    disabled: true
  }, {}, !!errorMessages && {
    errorText: errorMessages.join('\n')
  });

  var textAreaProps = _objectSpread({
    placeholder: textArea.hint,
    id: textArea.id,
    name: textArea.id,
    label: textArea.label || '',
    tabIndex: tabIndex,
    value: textArea.value || '',
    onChange: onChangeCallback
  }, nextProps);

  if (nextProps.hidden) {
    return null;
  }

  return React.createElement("div", {
    className: "sui-FormBuilder-field sui-FormBuilder-TextArea sui-FormBuilder-" + textAreaProps.id
  }, React.createElement(MoleculeTextAreaField, Object.assign({}, textAreaProps, {
    textCharacters: "caracteres",
    size: "long"
  })));
};

TextArea.displayName = 'TextArea';
export default TextArea;