import _regeneratorRuntime from "@babel/runtime/regenerator";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _asyncToGenerator from "@babel/runtime/helpers/esm/asyncToGenerator";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

import React, { useState, useEffect, useCallback } from 'react';
import PropTypes from 'prop-types';
import { json } from './prop-types';
import { reducer } from './reducer';
import { CHANGE } from './reducer/constants';
import { fieldsToObject, fieldsNamesInOrderOfDefinition } from './reducer/fields';
import ProxyField from './ProxyField';
import { inputSizes as fieldSizes } from '@s-ui/react-atom-input';
import AtomSpinner, { AtomSpinnerTypes } from '@s-ui/react-atom-spinner';

var FormBuilder = function FormBuilder(_ref) {
  var json = _ref.json,
      initFields = _ref.initFields,
      onChange = _ref.onChange,
      requestInterceptor = _ref.requestInterceptor,
      urlInterceptor = _ref.urlInterceptor,
      loader = _ref.loader,
      fieldSize = _ref.fieldSize,
      errors = _ref.errors;
  var _json$form = json.form,
      _json$form$fields = _json$form.fields,
      fields = _json$form$fields === void 0 ? [] : _json$form$fields,
      _json$form$rules = _json$form.rules,
      rules = _json$form$rules === void 0 ? {} : _json$form$rules,
      formID = _json$form.id;

  var _useState = useState(fields),
      stateFields = _useState[0],
      setStateFields = _useState[1];

  var HACK_KEY = "__PERFORMANCE_UGLY_HACK_STATE_FIELDS_" + formID + "__";

  var _useState2 = useState(false),
      stateShowSpinner = _useState2[0],
      setStateShowSpinner = _useState2[1];

  if (typeof window !== 'undefined') {
    window[HACK_KEY] = stateFields;
  }

  var handlerChange = useCallback(
  /*#__PURE__*/
  function () {
    var _ref2 = _asyncToGenerator(
    /*#__PURE__*/
    _regeneratorRuntime.mark(function _callee(id, value) {
      var reducerWithRules, timerShowSpinner, nextStateFields;
      return _regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              reducerWithRules = reducer(rules, formID, requestInterceptor, urlInterceptor);
              timerShowSpinner = setTimeout(function () {
                return setStateShowSpinner(true);
              }, FormBuilder.USER_MINIMAL_DELAY);
              _context.next = 4;
              return reducerWithRules(window[HACK_KEY], // safe for SSR
              {
                type: CHANGE,
                id: id,
                value: value
              });

            case 4:
              nextStateFields = _context.sent;
              clearTimeout(timerShowSpinner);
              setStateFields(nextStateFields);
              onChange(_objectSpread({}, fieldsToObject(nextStateFields), {
                __FIELD_CHANGED__: id // __META__: datalistEntries(nextStateFields)

              }));
              setStateShowSpinner(false);

            case 9:
            case "end":
              return _context.stop();
          }
        }
      }, _callee);
    }));

    return function (_x, _x2) {
      return _ref2.apply(this, arguments);
    };
  }(), []); // eslint-disable-line

  useEffect(function () {
    var reducerWithRules = reducer(rules, formID, requestInterceptor, urlInterceptor);
    var timerShowSpinner = setTimeout(function () {
      return setStateShowSpinner(true);
    }, FormBuilder.USER_MINIMAL_DELAY);
    fieldsNamesInOrderOfDefinition(fields).reduce(
    /*#__PURE__*/
    function () {
      var _ref3 = _asyncToGenerator(
      /*#__PURE__*/
      _regeneratorRuntime.mark(function _callee2(previousPromise, field) {
        var previousFields, nextFields;
        return _regeneratorRuntime.wrap(function _callee2$(_context2) {
          while (1) {
            switch (_context2.prev = _context2.next) {
              case 0:
                _context2.next = 2;
                return previousPromise;

              case 2:
                previousFields = _context2.sent;

                if (!(!initFields[field] || initFields[field] === '')) {
                  _context2.next = 5;
                  break;
                }

                return _context2.abrupt("return", previousFields);

              case 5:
                _context2.next = 7;
                return reducerWithRules(previousFields, {
                  type: CHANGE,
                  id: field,
                  value: initFields[field]
                });

              case 7:
                nextFields = _context2.sent;
                return _context2.abrupt("return", nextFields);

              case 9:
              case "end":
                return _context2.stop();
            }
          }
        }, _callee2);
      }));

      return function (_x3, _x4) {
        return _ref3.apply(this, arguments);
      };
    }(), Promise.resolve(window[HACK_KEY])).then(function (nextFields) {
      clearTimeout(timerShowSpinner);
      setStateFields(nextFields);
      setStateShowSpinner(false);
    });
  }, []); // eslint-disable-line

  return React.createElement("div", {
    className: "sui-FormBuilder"
  }, stateFields.map(function (field, index) {
    return React.createElement(ProxyField, {
      key: field.id,
      field: field,
      tabIndex: index + 1,
      onChange: handlerChange,
      fieldSize: fieldSize,
      errors: errors
    });
  }), stateShowSpinner && React.createElement(AtomSpinner, {
    type: AtomSpinnerTypes.SECTION,
    loader: loader
  }));
};

FormBuilder.USER_MINIMAL_DELAY = 250;
FormBuilder.displayName = 'FormBuilder';
FormBuilder.defaultProps = {
  initFields: {},
  onChange: function onChange() {},
  requestInterceptor: function requestInterceptor(_ref4) {
    var response = _ref4.response;
    return response;
  },
  urlInterceptor: function urlInterceptor() {},
  errors: {}
};
export { fieldSizes as formBuilderFieldSizes };
export { checkConstrainstsFactory } from './Standard';
export default FormBuilder;